package main

import (
	"fmt"
	"log"
	"path/filepath"

	"git.milar.in/nyaanime/logic"
	"git.milar.in/nyaanime/model"
	"git.milar.in/nyaanime/parsers"
	"github.com/fatih/color"
)

func HandleFile(path string) {
	color.Magenta("\nfile found: %s\n", filepath.Base(path))
	for _, parser := range parsers.Parsers {
		parsedFile, ok := parser.FileParser(&parser, path)
		if !ok {
			color.Red("\tnot parsable with parser '%s'\n", parser.Identity)
			continue
		}

		color.Green("\tparsable with parser '%s'\n", parser.Identity)

		anime, err := logic.SearchAnimeByTitle(parsedFile.OriginalAnimeTitle)
		if err != nil {
			color.Red("\tanime not found: '%s'\n", parsedFile.OriginalAnimeTitle)
			continue
		}

		parsedFile.Anime = anime
		HandleParsedFile(parsedFile)
		return
	}
}

func HandleParsedFile(parsedFile *model.ParsedFile) {
	newFilePrio := logic.NewFilePriority(parsedFile)
	oldFilePrio, animeEpNotExistLocally := logic.GetAnimeEpProps(parsedFile.AnimeEpisode())

	if !animeEpNotExistLocally || newFilePrio.Priority > oldFilePrio.Priority {
		fmt.Println("\tmove file")
		// go func(parsedFile *model.ParsedFile) {
		// 	if err := OrganizeAnimeEpisode(parsedFile); err != nil {
		// 		adverr.Println(err)
		// 	}
		// }(parsedFile)
	}
}

func OrganizeAnimeEpisode(parsedFile *model.ParsedFile) error {
	oldFile := filepath.Join(DownloadPath, parsedFile.File)
	newFile := logic.GetAnimeEpFilepath(parsedFile.AnimeEpisode(), filepath.Ext(parsedFile.File))
	//lockFile := logic.GetAnimeEpFilepath(parsedFile.AnimeEpisode(), "lock")

	log.Printf("move file '%s' to '%s'\n", oldFile, newFile)

	// if err := os.MkdirAll(filepath.Dir(newFile), os.ModePerm); err != nil {
	// 	return err
	// }

	// if err := os.Chown(filepath.Dir(newFile), Uid, Gid); err != nil {
	// 	return err
	// }

	// if _, err := os.Stat(newFile); !errors.Is(err, os.ErrNotExist) {
	// 	fmt.Fprintln(os.Stderr, "file already exists:", newFile)
	// 	return err
	// }

	// inputFile, err := os.Open(oldFile)
	// if err != nil {
	// 	return err
	// }
	// defer inputFile.Close()

	// outputFile, err := os.Create(newFile)
	// if err != nil {
	// 	return err
	// }
	// defer outputFile.Close()

	// if err := os.Chown(newFile, Uid, Gid); err != nil {
	// 	return err
	// }

	// _, err = io.Copy(outputFile, inputFile)
	// if err != nil {
	// 	return err
	// }

	// if err = os.Remove(oldFile); err != nil {
	// 	return err
	// }

	// if err = os.Remove(lockFile); err != nil {
	// 	return err
	// }

	log.Printf("file '%s' moved\n", newFile)

	return nil
}
